use strict;

my $line;
my $read;
my $gobj;
my @objs;
my $outfile;
my $numlm;

$read = 0;
$gobj = "";

$outfile = $ARGV[0];
$numlm = $ARGV[1];

open (IFILE, "< $outfile");

while($line = <IFILE>) {
	$gobj .= $line;	
}

close(IFILE);

my $i;
my $name;
my $curobj;
my $numVerts;
my $numFaces;
my $j;


# process objects

$outfile =~ /(.*)ase$/i;
$outfile = $1 . "lmc";
open (OFILE, "> $outfile");

print OFILE "Lightmaps: $numlm\n";

@objs = split(/\*GEOMOBJECT/, $gobj);

for ($i = 1; $i < @objs; $i++) {
	$curobj = $objs[$i];
	$curobj =~ /NODE_NAME\s*"([^\"]*)(.*)/s;
	$curobj = $2;
	$name = $1;
	$curobj =~ /(MESH_MAPPINGCHANNEL 3)(.*)/s;
	if ($1 eq "") {
		print "$name has no MESH_MAPPINGCHANNEL 3 TAG!\n";
		next;	
	}
	$curobj = $2;
	$curobj =~ /MESH_NUMTVERTEX\s*(\d*)(.*)/s;
	$curobj = $2;
	$numVerts = $1;
	print OFILE "$name $numVerts\n";
	for ($j = 0; $j < $numVerts; $j ++) {
		$curobj =~ /MESH_TVERT\s(\d*)\s*(\d\.\d*)\s*(\d\.\d*)(.*)/s;
		$curobj = $4;
		print OFILE "$2 $3\n";
	}
	$curobj = $2;
	$curobj =~ /MESH_NUMTVFACES\s*(\d*)(.*)/s;
	$curobj = $2;
	$numFaces = $1;
	print OFILE "$numFaces\n";
	for ($j = 0; $j < $numFaces; $j ++) {
		$curobj =~ /MESH_TFACE\s(\d*)\s*(\d*)\s*(\d*)\s*(\d*)(.*)/s;
		$curobj = $5;
		print OFILE "$2 $3 $4\n";
	}
}
close (OFILE);

# process lights

$outfile =~ /(.*)ase$/i;
$outfile = $1 . "lic";
open (OFILE, "> $outfile");

@objs = split(/LIGHTOBJECT/, $gobj);
for ($i = 1; $i < @objs; $i++) {
	$curobj = $objs[$i];
	$curobj =~ /NODE_NAME\s*"([^\"]*)(.*)/s;
	$curobj = $2;
	$name = $1;
	$curobj =~ /\*TM_POS\s*(-?\d*\.\d*)\s*(-?\d*\.\d*)\s*(-?\d*\.\d*)(.*)/s;
	print OFILE "$name $1 $2 $3\n";
	$curobj = $4;
	$curobj =~ /TIMEVALUE\s*(\d*)(.*)/s;
	# print STDERR "$1 \n";
}
close OFILE;
